--- elwix/config/rc.subr	2013/07/31 15:53:43	1.6.2.1
+++ elwix/config/rc.subr	2018/07/06 08:30:29	1.10.2.10
@@ -4,11 +4,16 @@
 # (C) AITNET ltd - Sofia/Bulgaria <office@aitnet.org>
 #    by Michael Pounov <misho@elwix.org>
 #
-# $Id: rc.subr,v 1.6.2.1 2013/07/31 15:53:43 misho Exp $
+# $Id: rc.subr,v 1.10.2.10 2018/07/06 08:30:29 misho Exp $
 #
 
 ### Dont edit this file !!!
 
+Die() {
+	echo -n "EXIT: " >&2; echo "$@" >&2
+	exit 1
+}
+
 CheckVer()
 {
 	[ -z "$1" -o ! -r "$1" ] && return 1
@@ -35,6 +40,15 @@ SnitVer()
 	return 0
 }
 
+Create_etc_motd()
+{
+	ELWIX_VER="ELWIX-${VERSION}_$2_${TARGET_ARCH}";
+	ELWIX_HDR_MOTD="${ELWIX_VER} :: Build date ${BUILD_DATE}";
+
+	awk -v fo="${1:-motd}" 'BEGIN { print "'"${ELWIX_HDR_MOTD}"'" > fo; } { print $0 >> fo; }' \
+		   ${CFGDIR}/elwix_signature.txt;
+}
+
 # $1 = fs/elwix
 # $2 = config/etc/default
 MakeFS_var()
@@ -42,29 +56,41 @@ MakeFS_var()
 	cd $1
 
 	install -d altroot;
+
+	install -d altroot/pkg;
+	install -d altroot/pkg/db;
+	install -d altroot/pkg/keys;
+	install -d altroot/pkg/keys/revoked;
+	install -d altroot/pkg/keys/trusted;
+
 	install -d altroot/var;
 	install -d altroot/var/account;
 	install -d altroot/var/at;
 	install -d altroot/var/at/jobs;
 	install -d altroot/var/at/spool;
 	install -d -g 63 -m 0770 altroot/var/authpf;
+	install -d altroot/var/backups;
 	install -d -m 0750 altroot/var/cron;
 	install -d -m 0700 altroot/var/cron/tabs;
 	install -d altroot/var/db;
+	install -d altroot/var/db/pkg;
 	install -d -m 0555 altroot/var/empty;
 	install -d altroot/var/log;
+	install -d -o 80 -g 80 -m 0700 altroot/var/log/lighttpd;
 	install -d -o 101 -g 101 altroot/var/log/quagga;
 	install -d -o 883 -g 883 altroot/var/mqtt;
-	install -d altroot/var/named;
+	install -d altroot/var/frm;
 	install -d altroot/var/run;
-	install -d altroot/var/sys;
-	install -d -o 53 -g 53 altroot/var/run/named;
+	install -d -o 80 -g 80 altroot/var/run/lighttpd;
 	install -d -o 101 -g 101 altroot/var/run/quagga;
 	install -d altroot/var/spool;
 	install -d -o 66 -g 68 -m 0775 altroot/var/spool/lock;
+	install -d -o 80 -g 80 -m 0775 altroot/var/spool/lighttpd;
+	install -d -o 80 -g 80 altroot/var/spool/lighttpd/sockets;
 	install -d -g 1 altroot/var/spool/lpd;
 	install -d -g 1 altroot/var/spool/output;
 	install -d -g 1 altroot/var/spool/output/lpd;
+	install -d -o 59 -g 59 altroot/var/unbound;
 
 	ln -fs /tmp altroot/var/tmp;
 
@@ -90,14 +116,100 @@ MakeFS_var()
 	touch altroot/var/log/ppp.log
 	chgrp 69 altroot/var/log/ppp.log
 
-	InstallDir ${WORLD}/var/named $1/altroot/var/named
-	InstallList ${ELWIX_BSDSRC} ${BSDSRC} $1/altroot/var/named
-	install -v $2/resolv.safe altroot/var/run/resolv.conf
+#	install -v $2/resolv.safe altroot/var/run/resolv.conf
+	install -v ${WORLD}/usr/share/keys/pkg/trusted/* altroot/pkg/keys/trusted
 
-	chown -hR root:wheel .
 	cd -
 }
 
+# $1 = fs/elwix
+# $2 = config/etc/default
+# $3 = name
+MakeFS_etc()
+{
+	InstallDir $2 $1/etc
+
+	chown -R root:wheel $1/etc;
+
+	case "$3" in
+		uboot)
+			;;
+		*)
+#			chmod 0600 $1/etc/opieaccess;
+#			chmod 0600 $1/etc/opiekeys;
+			;;
+	esac
+
+	chmod 0600 $1/etc/master.passwd;
+	chmod 0600 $1/etc/spwd.db;
+	chmod 0600 $1/etc/ssh/ssh_host_dsa_key;
+	chmod 0600 $1/etc/ssh/ssh_host_key;
+	chmod 0600 $1/etc/ssh/ssh_host_rsa_key;
+	chmod 0600 $1/etc/ssh/ssh_host_ecdsa_key;
+	chmod 0600 $1/etc/ssh/ssh_host_ed25519_key;
+
+	chmod 0440 $1/etc/sudoers;
+
+	mkdir -p $1/etc/mqtt;
+	chgrp -R 883 $1/etc/mqtt;
+	chown -R 883 $1/etc/mqtt;
+
+	ln -sf /etc/rc.s $1/etc/rc.S
+
+	ln -sf /usr/share/zoneinfo/${TIMEZONE} $1/etc/localtime;
+	ln -sf /usr/share/misc/termcap $1/etc/termcap;
+
+#	ln -sf /var/run/resolv.conf $1/etc/resolv.conf;
+
+#	ln -sf /elwix/pkg/etc/mk.conf $1/etc/mk.conf;
+
+	echo "${TARGET_ARCH} $3" >$1/etc/platform;
+
+	Create_etc_motd $1/etc/motd $3;
+
+	CleanCVS $1
+	CleanCVS $1/etc
+}
+
+# $1 = fs/elwix
+MakeFS_home()
+{
+	install -d $1/root/.ssh
+	[ -r ${CFGDIR}/root.skel/ssh/authorized_keys2 ] && \
+		install -v ${CFGDIR}/root.skel/ssh/authorized_keys2 $1/root/.ssh;
+
+	install -v ${CFGDIR}/root.skel/cshrc $1/root/.cshrc;
+	install -v ${CFGDIR}/root.skel/login $1/root/.login;
+	install -v ${CFGDIR}/root.skel/logout $1/root/.logout;
+	install -v ${CFGDIR}/root.skel/profile $1/root/.profile;
+	install -v ${CFGDIR}/root.skel/vimrc $1/root/.vimrc;
+}
+
+# $1 = fs
+MakeFS_boot()
+{
+	InstallDir ${WORLD}/boot $1/boot
+
+	install -m 644 ${CFGDIR}/boot/boot.config $1;
+
+	case ${TARGET} in
+		i386|amd64)
+			install -m 444 ${CFGDIR}/boot/logo-elwix.4th $1/boot;
+			install -m 444 ${CFGDIR}/boot/brand-elwix.4th $1/boot;
+			install -m 444 ${CFGDIR}/boot/menu.4th $1/boot;
+			;;
+		*)
+			;;
+	esac
+
+	install -m 444 ${KERNDEVHINTS} $1/boot/device.hints;
+
+	if [ -r ${CFGDIR}/boot/loader_${TARGET_ARCH}.conf ]; then
+		install -m 644 ${CFGDIR}/boot/loader_${TARGET_ARCH}.conf $1/boot/loader.conf;
+		install -m 644 ${CFGDIR}/boot/loader.conf.local $1/boot/loader.conf.local;
+	fi;
+}
+
 # $1 = ELWIX install list config
 # $2 = From World dir
 # $3 = To Dest dir
@@ -114,7 +226,8 @@ InstallList()
 	for i in $(cat $TMPFILE); do
 		if [ -x $i ]; then
 			echo "Strip '$i'"
-			strip -s $i
+			${CEXEC} chflags -f noschg $i
+			${CEXEC} strip -s $i
 		fi
 	done
 	cd -
@@ -150,6 +263,26 @@ InstallFiles()
 	fi
 }
 
+# $1 = From dir
+# $2 = To dir
+InstallLibs()
+{
+	${CEXEC} find -X $2 ! -name "*.ko" -and -type f | \
+		xargs readelf -d 2>&- | grep "NEEDED" | sort | uniq | \
+		awk '($2 == "(NEEDED)") { print substr($5, 2, length($5) - 2); }' \
+		2>/dev/null >${DEST}/elwix_mklibs.tmp
+	for i in $(cat ${DEST}/elwix_mklibs.tmp); do
+		echo $i
+		${CEXEC} find $1 -type f -name $i -exec install -v {} $LIBS \\\;
+		${CEXEC} chflags -f noschg $LIBS/$i
+		${CEXEC} strip -s $LIBS/$i
+	done
+#	${CEXEC} find -X $2 ! -name "*.ko" -and -type f -and -perm +111 | \
+#		xargs ldd -f "%p\n" 2> /dev/null | sort | uniq | \
+#		sed 's|^/||' >${DEST}/elwix_mklibs.conf
+#	InstallList ${DEST}/elwix_mklibs.conf $1 $2
+}
+
 # $1 = Directory for clean
 CleanCVS()
 {
@@ -173,7 +306,8 @@ StripFiles()
 		for i in $(cat $TMPFILE); do
 			if [ -x $i ]; then
 				echo "Strip '$i'"
-				strip -s $i
+				${CEXEC} chflags -f noschg $i
+				${CEXEC} strip -s $i
 			fi
 		done
 		cd -